use std::fmt::{Display, Formatter};

#[derive(Debug, PartialEq, Eq)]
pub struct DvmPointer {
    address: *mut u8,
    size: usize,
}

impl DvmPointer {
    pub fn new(address: *mut u8, size: usize) -> DvmPointer {
        DvmPointer { address, size }
    }

    pub fn address(&self) -> *mut u8 {
        self.address
    }

    pub fn size(&self) -> usize {
        self.size
    }
}

impl Display for DvmPointer {
    fn fmt(&self, f: &mut Formatter<'_>) -> std::fmt::Result {
        f.write_fmt(format_args!("0x{:x}", self.address as usize))
    }
}
